/// <reference types="node" />
import { DynamicModule, MiddlewareConsumer, OnModuleInit, NestModule } from '@nestjs/common';
import { AsyncLocalStorage } from 'async_hooks';
import { Connection } from 'typeorm';
import { DiscoveryService } from '@nestjs/core';
import { TypeOrmAlsAsyncModuleOptions, TypeOrmAlsModuleOptions } from './typeorm-als.interfaces';
export declare class TypeOrmAlsModule implements OnModuleInit, NestModule {
    private readonly asyncStorage;
    private readonly connection;
    private readonly discovery;
    static forRoot(options?: TypeOrmAlsModuleOptions): DynamicModule;
    static forRootAsync(options?: TypeOrmAlsAsyncModuleOptions): DynamicModule;
    private static createALS;
    constructor(asyncStorage: AsyncLocalStorage<Map<string, any>>, connection: Connection, discovery: DiscoveryService);
    onModuleInit(): any;
    configure(consumer: MiddlewareConsumer): any;
}
